#include <p24fxxxx.h>
#include <ports.h>
#include <timer.h>

/* Configuration Settings */
// OSC Input = XT + PLL
// CPU Clock =  ( 8000000 * 4 ) / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & ICS_PGx2 &
		  FWDTEN_OFF & WINDIS_OFF & FWPSA_PR128 & WDTPS_PS32768 )

_CONFIG2( IESO_OFF & FNOSC_PRIPLL & 
		  FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C2SEL_PRI & POSCMOD_XT )

_CONFIG3( WPEND_WPSTARTMEM & WPCFG_WPCFGDIS & WPDIS_WPDIS & WPFP_WPFP511 )

#define SystemFrequency		( ( 8000000L * 4 ) / 1 ) / 2
#define Timer1Tick			( SystemFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec	2

int main( void )
{
	// CPU Clock = PB Clock / 1
	CLKDIVbits.DOZEN = 0;

	// LEDI/O Port]wƦXAëwI/O PortAC
	mPORTAConfig( 0x00 );
	mPORTAWrite( 0x0f );

	OpenTimer1( T1_ON & T1_IDLE_CON & T1_GATE_OFF & T1_PS_1_256 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
			    Timer1Tick );

	while( 1 )
	{
		if( IFS0bits.T1IF )
		{
			IFS0bits.T1IF = 0;
			mPORTAToggleBits( 0xff );
		}
	}

	while( 1 );
}


