#include <p24fxxxx.h>
#include <ports.h>
#include <timer.h>
#include ".\..\App1632_LCM.h"
#include <adc.h>

/* Configuration Settings */
// OSC Input = XT + PLL
// CPU Clock =  ( 8000000 * 4 ) / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
_CONFIG1( JTAGEN_OFF & GCP_OFF & GWRP_OFF & ICS_PGx2 &
		  FWDTEN_OFF & WINDIS_OFF & FWPSA_PR128 & WDTPS_PS32768 )

_CONFIG2( IESO_OFF & FNOSC_PRIPLL & 
		  FCKSM_CSDCMD & OSCIOFNC_OFF & IOL1WAY_OFF & I2C2SEL_PRI & POSCMOD_XT )

_CONFIG3( WPEND_WPSTARTMEM & WPCFG_WPCFGDIS & WPDIS_WPDIS & WPFP_WPFP511 )

#define SystemFrequency		( ( 8000000L * 4 ) / 1 ) / 2
#define Timer1Tick			( SystemFrequency / 256 / Timer1TogglesPerSec )
#define Timer1TogglesPerSec	10

const unsigned char LCMString1[ ] = "PIC24FJ256GA110 "; 
const unsigned char LCMString2[ ] = "VR1:"; 
const unsigned char LCMString3[ ] = "VR2:"; 

unsigned int VR1Value = 0 , VR2Value = 0;

void __attribute__( ( interrupt , no_auto_psv ) ) _T1Interrupt( void )
{
	IFS0bits.T1IF = 0;

	ConvertADC10( );

	mPORTAToggleBits( 0xff );
}

int main( void )
{
	// CPU Clock = PB Clock / 1
	CLKDIVbits.DOZEN = 0;
 
 	// LEDI/O Port]wƦXAëwI/O PortAC
	mPORTAConfig( 0x00 );
	mPORTAWrite( 0x0f );

	LCM_Init( );

	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	OpenTimer1( T1_ON & T1_IDLE_CON & T1_GATE_OFF & T1_PS_1_256 & T1_SYNC_EXT_OFF & T1_SOURCE_INT ,
			    Timer1Tick );

	ConfigIntTimer1( T1_INT_ON & T1_INT_PRIOR_4 );

	// wqgzF, (adc.h ̭ٺ| ||defined( adc_v2_1 ) ).
	// C:\Program Files\Microchip\MPLAB C30\support\peripheral_24F\adc.h Line 588:
	// /*** AD1PCFGL register definition ***/
	// #if defined (adc_v1_1) || defined (adc_v1_2) || defined (adc_v1_3) || defined (adc_v1_4) || defined (adc_v1_5)
	// || defined (adc_v1_6) || defined (adc_v1_7) || defined (adc_v2_1)

	OpenADC10_v2( ADC_MODULE_ON & ADC_IDLE_CONTINUE & ADC_FORMAT_INTG & ADC_CLK_MANUAL & ADC_AUTO_SAMPLING_ON & ADC_SAMP_OFF ,
   				  ADC_VREF_AVDD_AVSS & ADC_SCAN_ON & ADC_INTR_2_CONV & ADC_ALT_BUF_OFF & ADC_ALT_INPUT_OFF ,
				  ADC_SAMPLE_TIME_31 & ADC_CONV_CLK_SYSTEM & ADC_CONV_CLK_64Tcy ,
				  ENABLE_AN5_ANA & ENABLE_AN4_ANA , 0 , 
				  ADC_SKIP_SCAN_AN0 & ADC_SKIP_SCAN_AN1 & ADC_SKIP_SCAN_AN2 & ADC_SKIP_SCAN_AN3 & ADC_SKIP_SCAN_AN6 &
				  ADC_SKIP_SCAN_AN7 & ADC_SKIP_SCAN_AN8 & ADC_SKIP_SCAN_AN9 & ADC_SKIP_SCAN_AN10 & ADC_SKIP_SCAN_AN11 &
				  ADC_SKIP_SCAN_AN12 & ADC_SKIP_SCAN_AN13 & ADC_SKIP_SCAN_AN14 & ADC_SKIP_SCAN_AN15 ,
				  0 );
	
	while( 1 )
	{
		// ഫ ?
		if( IFS0bits.AD1IF )
		{
			// MADC_X
			IFS0bits.AD1IF = 0;

			VR1Value = ( unsigned int ) ReadADC10( 1 );
			VR2Value = ( unsigned int ) ReadADC10( 0 );

			LCM_SetCursor( 0 , 1 );
			LCM_PutROMString( LCMString2 );
			LCM_PutNumber( VR1Value , 4 );
			LCM_PutASCII( ',' );
			LCM_PutROMString( LCMString3 );
			LCM_PutNumber( VR2Value >> 1 , 3 );
		}
	}

	while( 1 );
}
