#include <plib.h>
#include <p32xxxx.h>
#include ".\..\App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		2
#define Timer2ClockInPerMin	( ( PBFrequency / 64 ) * 60 )

const unsigned char LCMString1[ ] = "PIC32MX795F512L"; 
volatile unsigned int IC1Value = 0 , PreIC1Value = 0;
volatile unsigned char IC1Done = 0;

void __ISR( _TIMER_1_VECTOR , ipl4 ) ISR_Timer1( void )
{
	// MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

void __ISR( _INPUT_CAPTURE_1_VECTOR , ipl5 ) ISR_InputCapture1( void )
{
	// MTimer_XСC
	mIC1ClearIntFlag( );

	IC1Value = mIC1ReadCapture( );

	IC1Done = 1;
}

int main( void )
{
	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimer_Aëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// Timer]wC
	OpenTimer2( T2_ON | T2_IDLE_CON | T2_GATE_OFF | T2_PS_1_64 | T2_SOURCE_INT , 0xffff );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );

	// ҥInput Capture_Aëw䤤_uvC
	ConfigIntCapture1( IC_INT_ON | IC_INT_PRIOR_5 | IC_INT_SUB_PRIOR_0 );

	// ϥC32 Function]wInput CaptureC
	OpenCapture1( IC_ON | IC_IDLE_CON | IC_CAP_16BIT | IC_TIMER2_SRC | IC_INT_1CAPTURE | IC_EVERY_RISE_EDGE );

    INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		unsigned int Temporary = 0;

		// ഫ ?
		if( IC1Done )
		{
			IC1Done = 0;

			if( IC1Value > PreIC1Value )
				Temporary = IC1Value - PreIC1Value;
		
			else
				Temporary = ( 65535 - PreIC1Value ) + IC1Value;	

			// ]wCСAXADCƭȡC
			LCM_SetCursor( 0 , 1 );
			LCM_PutROMString( "RPM:" );
			LCM_PutNumber( Timer2ClockInPerMin / ( Temporary / 1 ) , 5 );
			LCM_PutROMString( ",Ct:" );
			LCM_PutNumber( Temporary >> 2 , 3 );

			PreIC1Value = IC1Value;
		}
	}

	while( 1 );
}
