#include <plib.h>
#include <p32xxxx.h>
#include ".\..\App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		1

const unsigned char LCMString1[ ] = "PIC32MX795F512L"; 
const unsigned char LCMString2[ ] = "Rx:            "; 
unsigned char UARTString1[ 32 ]; 
unsigned char Timer1TickFlag = 0;
unsigned char Hours = 0 , Mins = 0 , Secs = 0;

void UART_PutROMString( unsigned char * String );

#define UARTChannel UART2	/* UART2 for APP1632 */ 

void __ISR( _TIMER_1_VECTOR , ipl4 ) ISR_Timer1( void )
{
	Timer1TickFlag++;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

int main( void )
{
	unsigned char Cursor = 0;

	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// To Do : ϥC32 UART FunctionlUARTC
		// void UARTConfigure( UART_MODULE id , UART_CONFIGURATION flags );
		// void UARTSetFifoMode( UART_MODULE id , UART_FIFO_MODE mode );
		// void UARTSetLineControl( UART_MODULE id , UART_LINE_CONTROL_MODE mode );
		// UINT32 UARTSetDataRate( UART_MODULE id ,UINT32 sourceClock ,UINT32 dataRate );
		// void UARTEnable( UART_MODULE id , UART_ENABLE_MODE mode );

  	// MPLAB C32 1.11BP1.11A UART enum Label 
		// 1.11B				// 1.11A
		// #define UART2		UART3A
		// #define UART3		UART2A
		// #define UART4		UART1B
		// #define UART5		UART3B
		// #define UART6		UART2B
		// UART1 P UART1A wbHeader Filewq, (Ex: Ref. p32mx795f512l.h )

	UARTConfigure( UARTChannel , UART_ENABLE_PINS_TX_RX_ONLY );
	UARTSetFifoMode( UARTChannel , UART_INTERRUPT_ON_TX_NOT_FULL | UART_INTERRUPT_ON_RX_NOT_EMPTY );
	UARTSetLineControl( UARTChannel , UART_DATA_SIZE_8_BITS | UART_PARITY_NONE | UART_STOP_BITS_1 ); 
	UARTSetDataRate( UARTChannel , PBFrequency , 9600 );
	UARTEnable( UARTChannel , UART_ENABLE | UART_PERIPHERAL | UART_TX | UART_RX ); 

	Cursor = 3;

    INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		// UART ?
		if( UARTReceivedDataIsAvailable( UARTChannel ) )
		{
			// ]wCСAXrC
			LCM_SetCursor( Cursor++ , 1 );
			LCM_PutASCII( UARTGetDataByte( UARTChannel ) );

			if( Cursor > 15 ) Cursor = 3;
		}

		// BzC
		if( Timer1TickFlag >= 1 ) 	
		{
			if( ++Secs > 59 ) 
			{
				Secs = 0;
				if( ++Mins > 59 )
				{
					Mins = 0;
					if( ++Hours > 23 )
						Hours = 0;
				}
			}

			sprintf( UARTString1 , "Now Time %2d:%2d:%2d\r" ,
					 Hours , Mins , Secs );

 			// To Do : ϥC32 I/O UART FunctionNrzLUARTXC
			UART_PutROMString( UARTString1 );

			Timer1TickFlag--;
		}
	}

	while( 1 );
}

void UART_PutROMString( unsigned char * String ) 
{
	while ( *String != 0x00 )
	{
		while( !UARTTransmitterIsReady( UARTChannel ) );
	    UARTSendDataByte( UARTChannel , *String++ );
	}
}
