#include <plib.h>
#include <p32xxxx.h>
#include ".\..\App1632_LCM.h"

/* Configuration Settings */
// OSC Input = HS w/PLL
// CPU Clock = ( ( OSC Input / 2 ) * 15 ) / 1
// PB Clock = CPU Clock / 1 
// Disabld WDT , ICSP/ICD = PGC2 , PGD2 
#pragma config FNOSC = PRIPLL , POSCMOD = HS
#pragma config FPLLIDIV = DIV_2 , FPLLMUL = MUL_15 , FPLLODIV = DIV_1
#pragma config FPBDIV = DIV_8
#pragma config FWDTEN = OFF , ICESEL = ICS_PGx2

#define SystemFrequency		60000000L
#define PBFrequency			SystemFrequency / 8
#define Timer1Tick			( PBFrequency / 256 / TogglesPerSec )
#define TogglesPerSec		10

const unsigned char LCMString1[ ] = "PIC32MX795F512L "; 
const unsigned char LCMString2[ ] = "Write:  ,Read:  "; 
unsigned char Timer1TickFlag = 0;

void I2C_EE10BitsByteWirte( unsigned char SalveAddr , unsigned int Addr , unsigned char Data );
unsigned char I2C_EE10BitsRandomRead( unsigned char SalveAddr , unsigned int Addr );

#define I2CChannel I2C1	/* I2C1 or I2C2 for APP1632 */ 

void __ISR( _TIMER_1_VECTOR , ipl4 ) ISR_Timer1( void )
{
	Timer1TickFlag++;

	// MTimer_XСC
	mT1ClearIntFlag( );

	// LEDAϦVC	
	mPORTAToggleBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
}

int main( void )
{
	unsigned long i = 0;
	unsigned int I2CEEAddr = 0;

	// disable JTAG port
    DDPCONbits.JTAGEN = 0;

	// Pɯ = tήɯ / 8C
	OSCSetPBDIV( OSC_PB_DIV_8 );

	// ϥC32SYSTEM ConfigNCPUާ@̨ΤơAקFPBDIV]wC
	SYSTEMConfig( SystemFrequency , SYS_CFG_WAIT_STATES | SYS_CFG_PCACHE );
	// SYSTEMConfigPerformance( SystemFrequency  );
	// SYSTEMConfigWaitStates( SystemFrequency );

    // LEDI/O Port]wƦXAëwI/O PortAC
	mPORTASetPinsDigitalOut( BIT_0 | BIT_1 | BIT_2 | BIT_3 | BIT_4 | BIT_5 | BIT_6 | BIT_7 );
    mPORTASetBits( BIT_0 | BIT_1 | BIT_2 | BIT_3 );
	mPORTAClearBits( BIT_4 | BIT_5 | BIT_6 | BIT_7 );

	// ҥTimerAëw䤤_uvC
	ConfigIntTimer1( T1_INT_ON | T1_INT_PRIOR_4 );

	// Timer]wC
	OpenTimer1( T1_ON | T1_IDLE_CON | T1_GATE_OFF | T1_PS_1_256 | T1_SOURCE_INT , Timer1Tick );

	// LCMlơC
	LCM_Init( );

	// ]wCСAXrC
	LCM_SetCursor( 0 , 0 );
	LCM_PutROMString( LCMString1 );
	LCM_SetCursor( 0 , 1 );
	LCM_PutROMString( LCMString2 );

	// To Do : ϥC32 I2C FunctionlI2C ModuleC
	I2CConfigure( I2CChannel , 0 );
	I2CSetFrequency( I2CChannel , PBFrequency , 100000 );
	I2CSetSlaveAddress( I2CChannel , 0x00 , 0x00 , I2C_USE_7BIT_ADDRESS );
	I2CEnable( I2CChannel , 1 );

	// MPLAB C32 sª I2C s
		// New		// Old
		// I2C1		I2C1
		// I2C2		I2C2
		// I2C3		I2C1A
		// I2C4		I2C2A
		// I2C5		I2C3A

	INTEnableSystemMultiVectoredInt( );

	while( 1 )
	{
		if( Timer1TickFlag >= 1 )
 		{
			Timer1TickFlag--;

			LCM_SetCursor( 6 , 1 );
			LCM_PutHex( I2CEEAddr );
			I2C_EE10BitsByteWirte( 0xA0 , I2CEEAddr , I2CEEAddr ); 
		
			// ! EEPROMgJ, ݭn5mS, pGis, |_gJu@,
			// BH²檺n驵Bz, ѩ󤣦PsĶ,
			// n驵Ҳͪɶj@, SO`N!
			// Ϊ̧ĥεw骺pɨӳBz.
			for( i = 0; i < 50000L ; i++ );
			 
			LCM_SetCursor( 14 , 1 );
			LCM_PutHex( I2C_EE10BitsRandomRead( 0xA0 , I2CEEAddr ) );

			if( ++I2CEEAddr > 0xfff )
				I2CEEAddr = 0;
		}
	}

	while( 1 );
}

void I2C_EE10BitsByteWirte( unsigned char SalveAddr , unsigned int Addr , unsigned char Data )
{
	while( !I2CBusIsIdle( I2CChannel ) );
			
	I2CStart( I2CChannel );
 	while ( !( I2CGetStatus( I2CChannel ) & I2C_START ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , SalveAddr & 0xfffe );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , ( unsigned char ) ( ( Addr >> 8 ) & 0x00ff )  );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , ( unsigned char ) ( Addr & 0x00ff ) );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , Data );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	I2CStop( I2CChannel );
}

unsigned char I2C_EE10BitsRandomRead( unsigned char SalveAddr , unsigned int Addr )
{
	unsigned char Data = 0;

	while( !I2CBusIsIdle( I2CChannel ) );
			
	I2CStart( I2CChannel );
 	while ( !( I2CGetStatus( I2CChannel ) & I2C_START ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , SalveAddr & 0xfffe );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , ( unsigned char ) ( ( Addr >> 8 ) & 0x00ff )  );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , ( unsigned char ) ( Addr & 0x00ff ) );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	I2CRepeatStart( I2CChannel );
	while ( !( I2CGetStatus( I2CChannel ) & I2C_START ) );

	while( !I2CTransmitterIsReady( I2CChannel ) );
	I2CSendByte( I2CChannel , SalveAddr | 0x0001 );
	while( !I2CTransmissionHasCompleted( I2CChannel ) );
	while( !I2CByteWasAcknowledged( I2CChannel ) );

	I2CReceiverEnable( I2CChannel , 1 );

	while( !I2CReceivedDataIsAvailable( I2CChannel ) );
	Data = I2CGetByte( I2CChannel );

	I2CStop( I2CChannel );

	return Data;
}
